﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace GDI
{
    public partial class GDI : Form
    {
        Image kuva;
        Bitmap uusikuva;
        double kuva_paikka;
        double nopeus = -10.0;
        double y_nopeus = -5;
        double auto_y;
        double kulmakerroin;
        Point tie_alku;
        Point tie_loppu;
        List<Point> koords = new List<Point>();

        public GDI()
        {
            InitializeComponent();
            kuva = Image.FromFile("c:\\mytemp\\car.png");
            auto_y = tie_loppu.Y - kuva.Height;
            kuva_paikka = 1;
            // tehdään alustukset resize-tapahtuman yhteydessä niin toimii myös lomakkeen kokoa muutettaessa
            GDI_Resize(this, null);
            // lasketaan sinikäyrä
            for (int i = 0; i < ClientSize.Width ; i++)
            {
                koords.Add(new Point(i, (int)(Math.Sin(1.0 * i / 20.0) * (this.ClientRectangle.Height / 2) + this.ClientSize.Height / 2 )));
            }
            
            timerGDI.Enabled = true;
        }
        protected override void OnPaint(PaintEventArgs e)
        {
            Graphics dc = e.Graphics;
            dc.DrawImageUnscaled(uusikuva, new Point( (int)kuva_paikka, (int)auto_y));
            Pen kyna = new Pen(Brushes.Black, 10);
            // suora tie
            // dc.DrawLine(kyna, new Point(0, auto_y+kuva.Height), new Point(ClientSize.Width, auto_y+kuva.Height));

            // vino tie
            dc.DrawLine(kyna, tie_alku, tie_loppu);            

            string text1 = "Hello World";
            
            // using-lauseen avulla voi kiertää dispose-kutsuja. seuraava fontti on olemassa
            // vain using-lohkon ajan ja katoaa sitten muistista automaattisesti
            using (Font font1 = new Font("Arial", 12, FontStyle.Bold))
            {
                // tarvitaan alue, jonka sisälle keskitetään ja tässä tapauksessa koko lomake
                Rectangle rect1 = new Rectangle(0, 0, ClientSize.Width, ClientSize.Height);

                // stringformat-objektin avulla saadaan aikaan keskitys
                StringFormat stringFormat = new StringFormat();
                stringFormat.Alignment = StringAlignment.Center;
                stringFormat.LineAlignment = StringAlignment.Center;

                dc.DrawString(text1, font1, Brushes.Blue, rect1, stringFormat);
            }

            // aurinko
            dc.FillEllipse(Brushes.LightYellow, new Rectangle(ClientSize.Width-25, -25, 50, 50));
            // säteet sen ihmeemmin hienostelematta
            dc.DrawLine(Pens.LightYellow, new Point(ClientSize.Width, 0), new Point(ClientSize.Width-50, 15));
            dc.DrawLine(Pens.LightYellow, new Point(ClientSize.Width, 0), new Point(ClientSize.Width - 40, 25));
            dc.DrawLine(Pens.LightYellow, new Point(ClientSize.Width, 0), new Point(ClientSize.Width - 30, 35));
            dc.DrawLine(Pens.LightYellow, new Point(ClientSize.Width, 0), new Point(ClientSize.Width - 20, 45));
            dc.DrawLine(Pens.LightYellow, new Point(ClientSize.Width, 0), new Point(ClientSize.Width - 10, 55));


            dc.DrawLines(Pens.MediumAquamarine, koords.ToArray());

            // asetetaan keskipiste kääntöpisteeksi
            dc.TranslateTransform((float)ClientSize.Width / 2, (float)ClientSize.Height / 2);
            // käännetään kaikkia seuraavia operaatioita 90 astetta
            dc.RotateTransform(90);
            // pylväitä
            dc.FillRectangle(Brushes.Lime, new Rectangle(10, 100-79, 25, 79));
            dc.FillRectangle(Brushes.Magenta, new Rectangle(50, 100-81, 25, 81));
            dc.FillRectangle(Brushes.MediumBlue, new Rectangle(100, 100-75, 25, 75));

            using (Font font1 = new Font("Arial", 8, FontStyle.Regular))
            {
                dc.DrawString("demo1", font1, Brushes.Blue, 10, 100);
                dc.DrawString("demo2", font1, Brushes.Blue, 50, 100);
                dc.DrawString("demo3", font1, Brushes.Blue, 100, 100);
                // laskee paljonko tilaa tietty merkkijono vaatii tietyllä fontilla piirrettynä
                SizeF koko = e.Graphics.MeasureString("79", font1);
                // Käytetty kaikille samaa kokoa
                dc.DrawString("79", font1, Brushes.Blue, 10, 100-79-koko.Height);
                dc.DrawString("81", font1, Brushes.Blue, 50, 100 - 81 - koko.Height);
                dc.DrawString("75", font1, Brushes.Blue, 100, 100 - 75 - koko.Height);
            }
            // palautetaan normaalitilanne. Ei tarvittaisi tässä
            dc.TranslateTransform(-(float)ClientSize.Width/2, -(float)ClientSize.Height/2);
        }

        private void timerGDI_Tick(object sender, EventArgs e)
        {
            // ilman vinoa tietä:
            kuva_paikka += nopeus;
//            auto_y = auto_y - y_nopeus*kulmakerroin;
            auto_y = kulmakerroin * kuva_paikka + (tie_loppu.Y - kuva.Height);

            if (kuva_paikka <= 0 || kuva_paikka + kuva.Width >= ClientSize.Width)
            {
                y_nopeus = -y_nopeus;
                nopeus = -nopeus;
                // käännetään auto
                kuva.RotateFlip(RotateFlipType.Rotate180FlipY);
            }
            Invalidate();
        }

        private void GDI_Resize(object sender, EventArgs e)
        {
            tie_alku = new Point(ClientSize.Width, 100);
            tie_loppu = new Point(0, 50);
            kulmakerroin = (1.0 * (tie_alku.Y - tie_loppu.Y)) / (1.0 * (tie_alku.X - tie_loppu.X));
            // yksinkertainen nopeuden säätö. Pitäisi huomioida vielä auton suunta ja säätää sen mukaan
            if (kulmakerroin < 0) nopeus = 2 * nopeus;
            if (kulmakerroin > 0) nopeus = nopeus / 2;

            uusikuva = new Bitmap(kuva.Width, kuva.Height);
            Graphics dc = Graphics.FromImage(uusikuva);
            // asetetaan keskipiste kääntöpisteeksi
            dc.TranslateTransform((float)kuva.Width / 2, (float)kuva.Height / 2);
            // lasketaan kulma ja käännetään autoa
            float angle = 90*(float)Math.Atan(kulmakerroin);
            dc.RotateTransform(angle);
            dc.TranslateTransform(-(float)kuva.Width / 2, -(float)kuva.Height / 2);
            // piirretään edellisillä asetuksilla kuva
            dc.DrawImage(kuva, new Point(0, 0));
            Invalidate();
        }

    }
}
